<!doctype html>

<html lang="es">

    <head>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

        <!-- Bootstrap CSS -->
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/css/bootstrap.min.css" integrity="sha384-zCbKRCUGaJDkqS1kPbPd7TveP5iyJE0EjAuZQTgFLD2ylzuqKfdKlfG/eSrtxUkn" crossorigin="anonymous">

        <!-- Font Awesome -->
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@fortawesome/fontawesome-free@5.15.4/css/fontawesome.min.css" integrity="sha384-jLKHWM3JRmfMU0A5x5AkjWkw/EYfGUAGagvnfryNV3F9VqM98XiIH7VBGVoxVSc7" crossorigin="anonymous">

        <style>
            .bg-red      { background-color: lightsalmon;        }
            .bg-green    { background-color: lightgreen;         }
            .bg-blue     { background-color: lightskyblue;       }
            .bg-darkblue { background-color: rgb(85, 175, 211);       }
            .bg-purple   { background-color: rgb(204, 116, 204); }

            .bg-gray     { background-color: lightgray;          }


            .test-size      { min-height: 100px; }
            .half-test-size { min-height: 50px;  }
        </style>

        <title>XD</title>
    </head>

    <body>

        <div class="container">

            <div class="row m-1">
                <div class="col bg-green half-test-size">Header</div>
            </div>

            <div class="row m-1">
                <div class="offset-md-3 col-6 col-md-3 bg-darkblue test-size">1</div>
                <div class="col-6 col-md-3 bg-darkblue test-size">2</div>
                <div class="w-100"></div>
                <div class="col-6 col-md-3 bg-darkblue test-size">3</div>
                <div class="col d-none d-md-flex"></div>
                <div class="col-6 col-md-3 bg-darkblue test-size">4</div>
            </div>

            <div class="row d-none d-sm-flex d-md-none m-1">
                <div class="col bg-blue half-test-size">Tablet</div>
            </div>

            <div class="row m-1">
                <div class="col-6 col-sm-3 bg-gray test-size">a</div>
                <div class="col-6 col-sm-3 bg-gray test-size">b</div>
                <div class="col-6 col-sm-3 bg-gray test-size">c</div>
                <div class="col-6 col-sm-3 bg-gray test-size order-md-first">d</div>
            </div>

            <div class="row d-sm-none m-1">
                <div class="col bg-blue half-test-size">Mobile</div>
            </div>

            <div class="row d-none d-md-flex m-1">
                <div class="col bg-blue half-test-size">Desktop</div>
            </div>

            <div class="row m-1 justify-content-center">
                <div class="col col-md-3 bg-red test-size order-md-last">:D</div>
                <div class="col col-md-3 d-none d-sm-flex bg-red test-size">:(</div>
            </div>

            <div class="row m-1 d-none d-sm-flex">
                <div class="col bg-green half-test-size">Footer</div>
            </div>

        </div>


        <!-- jQuery and Bootstrap Bundle (includes Popper) -->
        <script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
        <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/js/bootstrap.bundle.min.js" integrity="sha384-fQybjgWLrvvRgtW6bFlB7jaZrFsaBXjsOMm/tB9LTS58ONXgqbR9W8oWht/amnpF" crossorigin="anonymous"></script>
    </body>

</html>
